﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel.Dispatcher;
using System.ServiceModel;
using System.ServiceModel.Channels;

namespace FirefoxWcfTest.Web.Services
{
    public class ClientCustomHeadersDispatchMessageInspector : IDispatchMessageInspector
    {
        // for demonstration purpose only!
        public static string LastReceivedHeader;

        public object AfterReceiveRequest(ref System.ServiceModel.Channels.Message request, System.ServiceModel.IClientChannel channel, System.ServiceModel.InstanceContext instanceContext)
        {
            if (System.Web.HttpContext.Current != null)
            {
                LastReceivedHeader = System.Web.HttpContext.Current.Request.Headers["X-MyCustomHeader"];
            }
            else
            {
                if (OperationContext.Current.IncomingMessageProperties.ContainsKey("httpRequest"))
                { 
                    var httpRequestProperties = 
                        OperationContext.Current.IncomingMessageProperties["httpRequest"] as HttpRequestMessageProperty;

                    LastReceivedHeader = httpRequestProperties.Headers["X-MyCustomHeader"];
                }
                else
                {
                    LastReceivedHeader = null;
                }
            }

            return null;
        }

        public void BeforeSendReply(ref System.ServiceModel.Channels.Message reply, object correlationState)
        {
        }
    }
}