﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ServiceModel.Dispatcher;
using System.ServiceModel.Channels;

namespace FirefoxWcfTest
{
    public class AttachingCustomHeadersClientMessageInspector : IClientMessageInspector
    {
        public static string MyCustomHeaderContent
        {
            get;
            set;
        }

        public void AfterReceiveReply(ref System.ServiceModel.Channels.Message reply, object correlationState)
        {			
        }

        public object BeforeSendRequest(ref System.ServiceModel.Channels.Message request, System.ServiceModel.IClientChannel channel)
        {
            if (request.Properties.ContainsKey(HttpRequestMessageProperty.Name))
            {
                HttpRequestMessageProperty property = (HttpRequestMessageProperty)request.Properties[HttpRequestMessageProperty.Name];
                property.Headers["X-MyCustomHeader"] = MyCustomHeaderContent;
            }
            else
            {
                HttpRequestMessageProperty property = new HttpRequestMessageProperty();
                property.Headers["X-MyCustomHeader"] = MyCustomHeaderContent;
                request.Properties.Add(HttpRequestMessageProperty.Name, property);
            }

            return null;
        }
    }
}
