﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace FirefoxWcfTest
{
    public partial class MainPage : UserControl
    {
        private MyServiceReference.MyServiceClient _client;

        public MainPage()
        {
            InitializeComponent();

            _client = new MyServiceReference.MyServiceClient();
            AttachingCustomHeadersEndpointBehavior endpointBehavior = new AttachingCustomHeadersEndpointBehavior();
            _client.Endpoint.Behaviors.Add(endpointBehavior);
            _client.GetLastCustomHeaderCompleted += new EventHandler<MyServiceReference.GetLastCustomHeaderCompletedEventArgs>(Client_GetLastCustomHeaderCompleted);
        }

        private void Client_GetLastCustomHeaderCompleted(object sender, MyServiceReference.GetLastCustomHeaderCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                AnswerText.Text = "An error occurred:" + Environment.NewLine + e.Error.ToString();
                return;
            }

            AnswerText.Text = e.Result;
        }

        private void SendButton_Click(object sender, RoutedEventArgs e)
        {
            AttachingCustomHeadersClientMessageInspector.MyCustomHeaderContent = CustomHeaderText.Text;
            _client.GetLastCustomHeaderAsync();
        }
    }
}
